diff --git a/src/backend/optimizer/plan/planner.c b/src/backend/optimizer/plan/planner.c
index 7fe11b5..1280388 100644
--- a/src/backend/optimizer/plan/planner.c
+++ b/src/backend/optimizer/plan/planner.c
@@ -455,10 +455,11 @@ standard_planner(Query *parse, int cursorOptions, ParamListInfo boundParams)
 		 * Ideally we'd use cost_gather here, but setting up dummy path data
 		 * to satisfy it doesn't seem much cleaner than knowing what it does.
 		 */
-		gather->plan.startup_cost = top_plan->startup_cost +
-			parallel_setup_cost;
-		gather->plan.total_cost = top_plan->total_cost +
-			parallel_setup_cost + parallel_tuple_cost * top_plan->plan_rows;
+		cost_set_member_add(&gather->plan.startup_cost, parallel_setup_cost, &top_plan->startup_cost);
+
+		cost_set_member_mul(&gather->plan.total_cost, parallel_tuple_cost, top_plan->plan_rows);
+		cost_add_member(&gather->plan.total_cost, parallel_setup_cost);
+		cost_add(&gather->plan.total_cost, &top_plan->total_cost);
 		gather->plan.plan_rows = top_plan->plan_rows;
 		gather->plan.plan_width = top_plan->plan_width;
 		gather->plan.parallel_aware = false;
@@ -533,7 +534,7 @@ standard_planner(Query *parse, int cursorOptions, ParamListInfo boundParams)
 
 	result->jitFlags = PGJIT_NONE;
 	if (jit_enabled && jit_above_cost >= 0 &&
-		top_plan->total_cost > jit_above_cost)
+		cost_asscalar(&top_plan->total_cost) > jit_above_cost)
 	{
 		result->jitFlags |= PGJIT_PERFORM;
 
@@ -541,10 +542,10 @@ standard_planner(Query *parse, int cursorOptions, ParamListInfo boundParams)
 		 * Decide how much effort should be put into generating better code.
 		 */
 		if (jit_optimize_above_cost >= 0 &&
-			top_plan->total_cost > jit_optimize_above_cost)
+			cost_asscalar(&top_plan->total_cost) > jit_optimize_above_cost)
 			result->jitFlags |= PGJIT_OPT3;
 		if (jit_inline_above_cost >= 0 &&
-			top_plan->total_cost > jit_inline_above_cost)
+			cost_asscalar(&top_plan->total_cost) > jit_inline_above_cost)
 			result->jitFlags |= PGJIT_INLINE;
 
 		/*
@@ -5790,7 +5791,7 @@ make_sort_input_target(PlannerInfo *root,
 				 * cpu_operator_cost".  Note this will take in any PL function
 				 * with default cost.
 				 */
-				if (cost.per_tuple > 10 * cpu_operator_cost)
+				if (cost_asscalar(&cost.per_tuple) > 10 * cpu_operator_cost)
 				{
 					postpone_col[i] = true;
 					have_expensive = true;
@@ -6206,13 +6207,14 @@ plan_cluster_use_sort(Oid tableOid, Oid indexOid)
 	 * expressions each time.  (XXX that's pretty inefficient...)
 	 */
 	cost_qual_eval(&indexExprCost, indexInfo->indexprs, root);
-	comparisonCost = 2.0 * (indexExprCost.startup + indexExprCost.per_tuple);
+	cost_set_sum2(&comparisonCost, &indexExprCost.startup, &indexExprCost.per_tuple);
+	cost_mul_scalar(&comparisonCost, 2);
 
 	/* Estimate the cost of seq scan + sort */
 	seqScanPath = create_seqscan_path(root, rel, NULL, 0);
 	cost_sort(&seqScanAndSortPath, root, NIL,
-			  seqScanPath->total_cost, rel->tuples, rel->reltarget->width,
-			  comparisonCost, maintenance_work_mem, -1.0);
+			  &seqScanPath->total_cost, rel->tuples, rel->reltarget->width,
+			  &comparisonCost, maintenance_work_mem, -1.0);
 
 	/* Estimate the cost of index scan */
 	indexScanPath = create_index_path(root, indexInfo,
@@ -6220,7 +6222,7 @@ plan_cluster_use_sort(Oid tableOid, Oid indexOid)
 									  ForwardScanDirection, false,
 									  NULL, 1.0, false);
 
-	return (seqScanAndSortPath.total_cost < indexScanPath->path.total_cost);
+	return cost_islt(&seqScanAndSortPath.total_cost, &indexScanPath->path.total_cost);
 }
 
 /*
diff --git a/src/backend/optimizer/plan/subselect.c b/src/backend/optimizer/plan/subselect.c
index 48b62a5..5780534 100644
--- a/src/backend/optimizer/plan/subselect.c
+++ b/src/backend/optimizer/plan/subselect.c
@@ -2060,7 +2060,7 @@ SS_identify_outer_params(PlannerInfo *root)
 void
 SS_charge_for_initplans(PlannerInfo *root, RelOptInfo *final_rel)
 {
-	Cost		initplan_cost;
+	Cost		initplan_cost = {0};
 	ListCell   *lc;
 
 	/* Nothing to do if no initPlans */
@@ -2073,12 +2073,11 @@ SS_charge_for_initplans(PlannerInfo *root, RelOptInfo *final_rel)
 	 * This is a conservative overestimate, since in fact an initPlan might be
 	 * executed later than plan startup, or even not at all.
 	 */
-	initplan_cost = 0;
 	foreach(lc, root->init_plans)
 	{
 		SubPlan    *initsubplan = (SubPlan *) lfirst(lc);
 
-		initplan_cost += initsubplan->startup_cost + initsubplan->per_call_cost;
+		cost_add2(&initplan_cost, &initsubplan->startup_cost, &initsubplan->per_call_cost);
 	}
 
 	/*
@@ -2088,8 +2087,8 @@ SS_charge_for_initplans(PlannerInfo *root, RelOptInfo *final_rel)
 	{
 		Path	   *path = (Path *) lfirst(lc);
 
-		path->startup_cost += initplan_cost;
-		path->total_cost += initplan_cost;
+		cost_add(&path->startup_cost, &initplan_cost);
+		cost_add(&path->total_cost, &initplan_cost);
 		path->parallel_safe = false;
 	}
 
diff --git a/src/backend/optimizer/prep/prepunion.c b/src/backend/optimizer/prep/prepunion.c
index b01c9bb..a9bf448 100644
--- a/src/backend/optimizer/prep/prepunion.c
+++ b/src/backend/optimizer/prep/prepunion.c
@@ -1025,6 +1025,7 @@ choose_hashed_setop(PlannerInfo *root, List *groupClauses,
 	Path		hashed_p;
 	Path		sorted_p;
 	double		tuple_fraction;
+	Cost 		zerocost = {0};
 
 	/* Check whether the operators support sorting or hashing */
 	can_sort = grouping_is_sortable(groupClauses);
@@ -1071,7 +1072,7 @@ choose_hashed_setop(PlannerInfo *root, List *groupClauses,
 	cost_agg(&hashed_p, root, AGG_HASHED, NULL,
 			 numGroupCols, dNumGroups,
 			 NIL,
-			 input_path->startup_cost, input_path->total_cost,
+			 &input_path->startup_cost, &input_path->total_cost,
 			 input_path->rows);
 
 	/*
@@ -1081,9 +1082,9 @@ choose_hashed_setop(PlannerInfo *root, List *groupClauses,
 	sorted_p.startup_cost = input_path->startup_cost;
 	sorted_p.total_cost = input_path->total_cost;
 	/* XXX cost_sort doesn't actually look at pathkeys, so just pass NIL */
-	cost_sort(&sorted_p, root, NIL, sorted_p.total_cost,
+	cost_sort(&sorted_p, root, NIL, &sorted_p.total_cost,
 			  input_path->rows, input_path->pathtarget->width,
-			  0.0, work_mem, -1.0);
+			  &zerocost, work_mem, -1.0);
 	cost_group(&sorted_p, root, numGroupCols, dNumGroups,
 			   NIL,
 			   sorted_p.startup_cost, sorted_p.total_cost,
diff --git a/src/backend/optimizer/util/appendinfo.c b/src/backend/optimizer/util/appendinfo.c
index 1890f25..099bb43 100644
--- a/src/backend/optimizer/util/appendinfo.c
+++ b/src/backend/optimizer/util/appendinfo.c
@@ -18,6 +18,7 @@
 #include "nodes/makefuncs.h"
 #include "nodes/nodeFuncs.h"
 #include "optimizer/appendinfo.h"
+#include "optimizer/cost.h"
 #include "parser/parsetree.h"
 #include "utils/lsyscache.h"
 #include "utils/rel.h"
@@ -461,7 +462,7 @@ adjust_appendrel_attrs_mutator(Node *node,
 		 * don't reset left_ec/right_ec: each child variable is implicitly
 		 * equivalent to its parent, so still a member of the same EC if any.
 		 */
-		newinfo->eval_cost.startup = -1;
+		cost_zero(&newinfo->eval_cost.startup); // XXX
 		newinfo->norm_selec = -1;
 		newinfo->outer_selec = -1;
 		newinfo->left_em = NULL;
diff --git a/src/backend/optimizer/util/clauses.c b/src/backend/optimizer/util/clauses.c
index a04b622..9668762 100644
--- a/src/backend/optimizer/util/clauses.c
+++ b/src/backend/optimizer/util/clauses.c
@@ -370,8 +370,8 @@ get_agg_clause_costs_walker(Node *node, get_agg_clause_costs_context *context)
 		{
 			/* add the input expressions' cost to per-input-row costs */
 			cost_qual_eval_node(&argcosts, (Node *) aggref->args, context->root);
-			costs->transCost.startup += argcosts.startup;
-			costs->transCost.per_tuple += argcosts.per_tuple;
+			cost_add(&costs->transCost.startup, &argcosts.startup);
+			cost_add(&costs->transCost.per_tuple, &argcosts.per_tuple);
 
 			/*
 			 * Add any filter's cost to per-input-row costs.
@@ -384,8 +384,8 @@ get_agg_clause_costs_walker(Node *node, get_agg_clause_costs_context *context)
 			{
 				cost_qual_eval_node(&argcosts, (Node *) aggref->aggfilter,
 									context->root);
-				costs->transCost.startup += argcosts.startup;
-				costs->transCost.per_tuple += argcosts.per_tuple;
+				cost_add(&costs->transCost.startup, &argcosts.startup);
+				cost_add(&costs->transCost.per_tuple, &argcosts.per_tuple);
 			}
 		}
 
@@ -397,8 +397,8 @@ get_agg_clause_costs_walker(Node *node, get_agg_clause_costs_context *context)
 		{
 			cost_qual_eval_node(&argcosts, (Node *) aggref->aggdirectargs,
 								context->root);
-			costs->finalCost.startup += argcosts.startup;
-			costs->finalCost.per_tuple += argcosts.per_tuple;
+			cost_add(&costs->finalCost.startup, &argcosts.startup);
+			cost_add(&costs->finalCost.per_tuple, &argcosts.per_tuple);
 		}
 
 		/*
@@ -4631,7 +4631,7 @@ inline_function(Oid funcid, Oid result_type, Oid result_collid,
 			if (contain_subplans(param))
 				goto fail;
 			cost_qual_eval(&eval_cost, list_make1(param), NULL);
-			if (eval_cost.startup + eval_cost.per_tuple >
+			if (cost_asscalar(&eval_cost.startup) + cost_asscalar(&eval_cost.per_tuple) >
 				10 * cpu_operator_cost)
 				goto fail;
 
